diff --git a/src/include/access/nbtree.h b/src/include/access/nbtree.h
index 42c66fac57..e04c000236 100644
--- a/src/include/access/nbtree.h
+++ b/src/include/access/nbtree.h
@@ -159,16 +159,16 @@ typedef struct BTMetaPageData
  * a heap index tuple to make space for a tiebreaker heap TID
  * attribute, which we account for here.
  */
-#define BTMaxItemSize(page) \
+#define BTMaxItemSize(page, tdeNonceSize) \
 	MAXALIGN_DOWN((PageGetPageSize(page) - \
 				   MAXALIGN(SizeOfPageHeaderData + \
 							3*sizeof(ItemIdData)  + \
 							3*sizeof(ItemPointerData)) - \
-				   MAXALIGN(sizeof(BTPageOpaqueData))) / 3)
-#define BTMaxItemSizeNoHeapTid(page) \
+				   MAXALIGN(sizeof(BTPageOpaqueData) + tdeNonceSize)) / 3)
+#define BTMaxItemSizeNoHeapTid(page, tdeNonceSize) \
 	MAXALIGN_DOWN((PageGetPageSize(page) - \
 				   MAXALIGN(SizeOfPageHeaderData + 3*sizeof(ItemIdData)) - \
-				   MAXALIGN(sizeof(BTPageOpaqueData))) / 3)
+				   MAXALIGN(sizeof(BTPageOpaqueData) + tdeNonceSize)) / 3)
 
 /*
  * MaxTIDsPerBTreePage is an upper bound on the number of heap TIDs tuples
@@ -885,7 +885,7 @@ typedef struct BTDedupStateData
 	 * are implicitly unchanged by deduplication pass).
 	 */
 	int			nintervals;		/* current number of intervals in array */
-	BTDedupInterval intervals[MaxIndexTuplesPerPage];
+	BTDedupInterval intervals[MaxIndexTuplesPerPageLimit];
 } BTDedupStateData;
 
 typedef BTDedupStateData *BTDedupState;
diff --git a/src/include/access/spgist_private.h b/src/include/access/spgist_private.h
index ba3da5b540..481737ac5e 100644
--- a/src/include/access/spgist_private.h
+++ b/src/include/access/spgist_private.h
@@ -226,14 +226,14 @@ typedef struct SpGistScanOpaqueData
 	TupleDesc	reconTupDesc;	/* if so, descriptor for reconstructed tuples */
 	int			nPtrs;			/* number of TIDs found on current page */
 	int			iPtr;			/* index for scanning through same */
-	ItemPointerData heapPtrs[MaxIndexTuplesPerPage];	/* TIDs from cur page */
-	bool		recheck[MaxIndexTuplesPerPage]; /* their recheck flags */
-	bool		recheckDistances[MaxIndexTuplesPerPage];	/* distance recheck
+	ItemPointerData heapPtrs[MaxIndexTuplesPerPageLimit];	/* TIDs from cur page */
+	bool		recheck[MaxIndexTuplesPerPageLimit]; /* their recheck flags */
+	bool		recheckDistances[MaxIndexTuplesPerPageLimit];	/* distance recheck
 															 * flags */
-	HeapTuple	reconTups[MaxIndexTuplesPerPage];	/* reconstructed tuples */
+	HeapTuple	reconTups[MaxIndexTuplesPerPageLimit];	/* reconstructed tuples */
 
 	/* distances (for recheck) */
-	IndexOrderByDistance *distances[MaxIndexTuplesPerPage];
+	IndexOrderByDistance *distances[MaxIndexTuplesPerPageLimit];
 
 	/*
 	 * Note: using MaxIndexTuplesPerPage above is a bit hokey since
@@ -444,10 +444,10 @@ typedef SpGistDeadTupleData *SpGistDeadTuple;
  */
 
 /* Page capacity after allowing for fixed header and special space */
-#define SPGIST_PAGE_CAPACITY  \
+#define SPGIST_PAGE_CAPACITY(tdeNonceSize)  \
 	MAXALIGN_DOWN(BLCKSZ - \
 				  SizeOfPageHeaderData - \
-				  MAXALIGN(sizeof(SpGistPageOpaqueData)))
+				  MAXALIGN(sizeof(SpGistPageOpaqueData) + tdeNonceSize))
 
 /*
  * Compute free space on page, assuming that up to n placeholders can be
diff --git a/src/include/storage/fsm_internals.h b/src/include/storage/fsm_internals.h
index 09749769b3..090619601f 100644
--- a/src/include/storage/fsm_internals.h
+++ b/src/include/storage/fsm_internals.h
@@ -48,17 +48,18 @@ typedef FSMPageData *FSMPage;
  * Number of non-leaf and leaf nodes, and nodes in total, on an FSM page.
  * These definitions are internal to fsmpage.c.
  */
-#define NodesPerPage (BLCKSZ - MAXALIGN(SizeOfPageHeaderData) - \
+#define NodesPerPage(tdeNonceSize) (BLCKSZ - MAXALIGN(SizeOfPageHeaderData) - \
+					  MAXALIGN(tdeNonceSize) - \
 					  offsetof(FSMPageData, fp_nodes))
 
 #define NonLeafNodesPerPage (BLCKSZ / 2 - 1)
-#define LeafNodesPerPage (NodesPerPage - NonLeafNodesPerPage)
+#define LeafNodesPerPage(tdeNonceSize) (NodesPerPage(tdeNonceSize) - NonLeafNodesPerPage)
 
 /*
  * Number of FSM "slots" on a FSM page. This is what should be used
  * outside fsmpage.c.
  */
-#define SlotsPerFSMPage LeafNodesPerPage
+#define SlotsPerFSMPage(tdeNonceSize) LeafNodesPerPage(tdeNonceSize)
 
 /* Prototypes for functions in fsmpage.c */
 extern int	fsm_search_avail(Buffer buf, uint8 min_cat, bool advancenext,
diff --git a/src/test/modules/test_ginpostinglist/test_ginpostinglist.c b/src/test/modules/test_ginpostinglist/test_ginpostinglist.c
index 7ce515fcb7..e24ee54de2 100644
--- a/src/test/modules/test_ginpostinglist/test_ginpostinglist.c
+++ b/src/test/modules/test_ginpostinglist/test_ginpostinglist.c
@@ -88,9 +88,9 @@ Datum
 test_ginpostinglist(PG_FUNCTION_ARGS)
 {
 	test_itemptr_pair(0, 2, 14);
-	test_itemptr_pair(0, MaxHeapTuplesPerPage, 14);
-	test_itemptr_pair(MaxBlockNumber, MaxHeapTuplesPerPage, 14);
-	test_itemptr_pair(MaxBlockNumber, MaxHeapTuplesPerPage, 16);
+	test_itemptr_pair(0, MaxHeapTuplesPerPage(tde_nonce_size), 14);
+	test_itemptr_pair(MaxBlockNumber, MaxHeapTuplesPerPage(tde_nonce_size), 14);
+	test_itemptr_pair(MaxBlockNumber, MaxHeapTuplesPerPage(tde_nonce_size), 16);
 
 	PG_RETURN_VOID();
 }
-- 
2.25.1

